#!/usr/bin/env ruby
require 'threadmanager'
require 'open-uri'

def main(args)
  ThreadManager.run(3) { |fm|
    args.each { |arg|
      number = arg.to_i
      fm.start {
        fetch_rfc(number)
      }
    }
  }
  puts "Done!"
end

def fetch_rfc(number)
  puts "Trying to fetch RFC#{number}..."
  uri = rfc_uri(number)
  body = uri.read
  File.open(File.basename(uri.path), "w") { |fh|
    fh.print body
  }
  puts "Finished fetching RFC#{number}."
end

def rfc_uri(number)
  URI.parse("http://www.ietf.org/rfc/rfc#{number}.txt")
end

main(ARGV)

# fetch_rfc.rb 2648 3043 3044 3061 3085 3120 3121 3151 3187
